/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

 #warning make unselect handler to set selected_pid back to -1

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <time.h>


#include "interface.h"
#include "support.h"
#include "main.h"

int main (int argc, char *argv[])
{
  GtkWidget *mainwin;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  check_dirs();

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  mainwin = create_mainwin ();
  gtk_widget_show (mainwin);
  gtk_signal_connect(GTK_OBJECT (mainwin), "delete_event", (GtkSignalFunc) gtk_exit, NULL);

  gtk_main ();
  return 0;
}

void check_dirs()
{
  int fd;
  char buf[PATH_MAX], *homedir = (char *)getenv("HOME");

  strcpy(buf, homedir);
  strcat(buf, "/.lsalarm");
  if((fd = open(buf, O_RDWR)) == -1)
  {
    mkdir(buf, 0770);
    strcat(buf, "/sessions");
    mkdir(buf, 0770);
  }
  else
  {
    close(fd);
    strcat(buf, "/sessions");
    if((fd = open(buf, O_RDWR)) == -1)
    {
      mkdir(buf, 0770);
      close(fd);
    }
    else close(fd);
  }
}

void refresh_mainlist(GtkCList *mainlist)
{
  int i = 0, j = 0, num_sessions = 0;
  gchar *list[MAX_SESSIONS][7];
  DIR *dirp;
  char buf[PATH_MAX], *homedir = (char *)getenv("HOME");

  strcpy(buf, homedir);
  strcat(buf, "/.lsalarm/sessions");

  for(i = 0; i < MAX_SESSIONS; i++) for(j = 0; j < 7; j++)
  {
    list[i][j] = malloc(sizeof(char)*LISTENTRY_LENGTH);

    if(!list[i][j])
    {
      fprintf(stderr, "Out of memory!\n\n");
      gtk_main_quit();
      return;
    }
  }

  i = j = 0;
  if((dirp = opendir(buf)) != NULL)
  {
    struct dirent *dp;
    char buf2[PATH_MAX];

    while(errno == 0 && (dp = readdir(dirp)) != NULL)
    {
      int k = 0;

      if(strcmp(dp->d_name, ".") == 0 || strcmp(dp->d_name, "..") == 0)
        continue;

      /*Fill in most of the fields*/
      sprintf(buf2, "%s/%s", buf, dp->d_name);
      fill_fields(buf2, list[i]);

      while(dp->d_name[j] != '.') j++;
      k = j+1;
      while(dp->d_name[k] != '.') k++;
      dp->d_name[k] = 0;

      /*Id field*/
      strcpy(list[i][0], dp->d_name+j+1);

      /*Status field*/
      if(check_session(atoi(list[i][0])) == 1)
        strcpy(list[i][1], "Waiting");
      else
      {
        strcpy(list[i][1], "Dead");
        errno = 0;
      }

      i++;
      num_sessions++;
    }

    closedir(dirp);
  }
  else
  {
    fprintf(stderr, "~/.lsalarm/sessions open failed!!!!  Check your permissions or create a $HOME env variable\n\n");
    gtk_main_quit();
  }

  gtk_clist_clear((GtkCList *)mainlist);
  for (i = 0; i < num_sessions; i++)
  {
    gtk_clist_append ((GtkCList *)mainlist, list[i]);
  }

  for(i = 0; i < MAX_SESSIONS; i++) for(j = 0; j < 7; j++)
  {
    free(list[i][j]);
  }
}


int check_session(int id)
{
  char buf[PATH_MAX], str_id[20], *homedir = (char *)getenv("HOME");
  FILE *test;
  int ret;

  sprintf(str_id, "%d", id);
  strcpy(buf, homedir);
  strcat(buf, "/.lsalarm/");
  strcat(buf, str_id);

  kill(id, SIGUSR2);
  sleep_little();

  test = fopen(buf, "r");
  if(test)
  {
    fclose(test);
    remove(buf);
    ret = 1;
  }
  else
  {
    ret = 0;
  }

  return ret;
}

void fill_fields(char *sessionfile, gchar *fields[7])
{
  FILE *file = fopen(sessionfile, "r");
  char line[512], str[512];
  int des_hr, des_min, repeat_sound;

  if(file)
  {
    int ps_id, sound_tmp, i;

    while(fgets(line, 512, file))
    {
      if(sscanf(line, "Waiting for alarm at:  %d:%d", &des_hr, &des_min) == 2)
      {
        sprintf(fields[2], "%d:%.2d", des_hr, des_min);
      }
      else if(strstr(line, "Alarm str is"))
      {
        i = 0;
        while(line[++i] != ':') ;

        strcpy(str, line+i+3);
        for(i = 0; str[i]; i++)
        {
          if(str[i] == '\n')
            str[i] = 0;
        }
        strcpy(fields[3], str);
      }
      else if(strstr(line, "Sound file is"))
      {
        i = 0;
        while(line[++i] != ':') ;

        strcpy(str, line+i+3);
        for(i = 0; str[i]; i++)
        {
          if(str[i] == '\n')
            str[i] = 0;
        }

        strcpy(fields[4], str);
      }
      else if(strstr(line, "Command str is"))
      {
        i = 0;
        while(line[++i] != ':') ;

        strcpy(str, line+i+3);
        for(i = 0; str[i]; i++)
        {
          if(str[i] == '\n')
            str[i] = 0;
        }
        /*if(str[0] != 0)
          ex_command = TRUE;*/
        sprintf(fields[5], str);
      }
      else if(sscanf(line, "Repeating:  %d\n", &sound_tmp))
      {
        repeat_sound = sound_tmp;

        if(repeat_sound)
          strcpy(fields[6], "Yes");
        else strcpy(fields[6], "No");
      }
    }
  }
}


void sleep_little()
{
  /*                           100 ms*/
  struct timespec req = { 0,  100000000 };

  nanosleep(&req, NULL);
}


void msg_box(char *msg, char *msg_title)
{
  GtkWidget *msgwin, *label, *button, *vbox, *hbox, *image, *align;

  msgwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(msgwin, -1, -1);
  gtk_window_set_title(GTK_WINDOW (msgwin), msg_title);
  gtk_window_set_position(GTK_WINDOW (msgwin), GTK_WIN_POS_CENTER);
  gtk_window_set_resizable(GTK_WINDOW (msgwin), FALSE);
  gtk_container_border_width(GTK_CONTAINER (msgwin), 15);
  gtk_signal_connect(GTK_OBJECT (msgwin), "delete_event", (GtkSignalFunc) gtk_exit, NULL);

  vbox = gtk_vbox_new (TRUE, 10);
  gtk_widget_show (vbox);
  gtk_container_add(GTK_CONTAINER (msgwin), vbox);

  label = gtk_label_new(msg);
  gtk_container_add(GTK_CONTAINER (vbox), label);
  gtk_widget_show(label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);

  button = gtk_button_new();
  gtk_widget_show(button);

  align = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (align);
  gtk_container_add (GTK_CONTAINER (button), align);

  hbox = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox);
  gtk_container_add(GTK_CONTAINER (align), hbox);

  image = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image);
  gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER (vbox), button);
  gtk_signal_connect_object(GTK_OBJECT (button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT(msgwin));

  label = gtk_label_new("Ok");
  gtk_container_add(GTK_CONTAINER (hbox), label);
  gtk_widget_show(label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_widget_set_size_request (label, 35, -1);

  gtk_widget_show(msgwin);
}
